#ifndef __FILEDOWNLOADER_HPP__
#define __FILEDOWNLOADER_HPP__


#include <QObject>
#include <QByteArray>
#include <QtNetwork/QNetworkAccessManager>
#include <QtNetwork/QNetworkRequest>
#include <QtNetwork/QNetworkReply>


class FileDownloader : public QObject
{
  Q_OBJECT
public:
  explicit FileDownloader(QUrl imageUrl, QObject *parent = 0);

  virtual ~FileDownloader();

  QByteArray downloadedData() const;

signals:
  void downloaded();

  private slots:

  void fileDownloaded(QNetworkReply* pReply);

private:

  QNetworkAccessManager m_WebCtrl;

  QByteArray m_DownloadedData;

};





#endif
