#include "OSCDialog.hpp"
#include "ui_OSCDialog.h"
#include <iostream>
#include "WorldEngine.hpp"
#include <QSettings>
#include "Utilities.hpp"

OSCDialog::OSCDialog(QWidget* parent, Qt::WindowFlags f): 
  QDialog(parent, f),
  ui(new Ui::OSCDialog)
{
  ui->setupUi(this);
  QSettings settings;
  ui->ip_edit->setText(settings.value("IP_ADDRESS").toString());
  DebugStream << settings.value("IP_ADDRESS").toString().toStdString() <<std::endl;
}
void OSCDialog::accept()
{
    DebugStream << ui->ip_edit->text().toStdString() << "\t"<<  ui->port_edit->text().toStdString()<<std::endl; 
    WorldEngine::get_instance().set_lo_address(ui->ip_edit->text().toAscii(),ui->port_edit->text().toAscii());
    QSettings settings;
    settings.setValue("IP_ADDRESS", ui->ip_edit->text()  );
    DebugStream << settings.fileName().toStdString()<<std::endl;
    QDialog::accept();
}
