#ifndef PHYSICSMOTIONMODEL_HPP
#define PHYSICSMOTIONMODEL_HPP

#include "MotionModel.hpp"

class PhysicsMotionModel : public MotionModel
{

public:
    PhysicsMotionModel(TreeNode* parent);
    virtual MotionModel::MotionType is_type() const;
    virtual void tick(double Dt);
    virtual void compute_grid_attraction(double Dt);
};

#endif // PHYSICSMOTIONMODEL_HPP
