#ifndef PROPERTYDELEGATE_HPP
#define PROPERTYDELEGATE_HPP

#include "TreeNode.hpp"
#include <QItemDelegate>

class PropertyDelegate : public QItemDelegate
{
  Q_OBJECT
public:
  explicit PropertyDelegate(QObject* parent);
  virtual QWidget* createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index) const;
  virtual void setEditorData(QWidget* editor, const QModelIndex& index) const; 
  virtual void setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const;
//   virtual void updateEditorGeometry(QWidget* editor, const QStyleOptionViewItem& option, const QModelIndex& index) const;
};

#endif // PROPERTYDELEGATE_HPP
