function find_red_max( pos, thres )
  local ret = pos
  local max = thres
  for n = 0, 10, 1 do
    local a = (2 * math.pi / 10) * n
    local v = pos - Vec2.new(math.cos(a)*5,math.sin(a)*5)
    local mag = getRedFromPoint(0,v)
    if mag > max then
      max = mag
      ret = v
    end
  end
  return ret
end



function find_green_max( pos, thres )
  local ret = pos
  local max = thres
  for n = 0, 10, 1 do
    local a = (2 * math.pi / 10) * n
    local v = pos - Vec2.new(math.cos(a)*5,math.sin(a)*5)
    local mag = getRedFromPoint(0,v)
    if mag > max then
      max = mag
      ret = v
    end
  end
  return ret
end



function find_blue_max( pos, thres )
  local ret = pos
  local max = thres
  for n = 0, 10, 1 do
    local a = (2 * math.pi / 10) * n
    local v = pos - Vec2.new(math.cos(a)*5,math.sin(a)*5)
    local mag = getRedFromPoint(0,v)
    if mag > max then
      max = mag
      ret = v
    end
  end
  return ret
end


function ai_RedAttractor()
  initai()
  addP("thresh",100)

  while true do
    local pos =  getP("pos")
    local target = find_red_max(pos,getP("thresh"))
    if target:x() == pos:x() and target:y() == pos:y() then
      break
    end 

    setP("pos", target)
    local col = getRGBA(0,target)
    drawCircle(0,target,2,col * 0.75,2)
   -- print(target)
    pause(0.1)  
  end
  die()
end

function zeroOneRandom()
  local val = math.random(0,1000) * 0.001
  return val
end


function ai_ColourRandomiser()
  initai()
  setP("Velocity",Vec2.new( math.random(-10,10),math.random(-10,10)  ))
  local pos
  for i=1,100 do
        pos = getP("pos")

      pause(0.01)
    end

end