--Here you will find a collection of basic soundfile players. 
--These do not update over the course of an Agents lifetime.

function ai_BasicPlayer()
	initai()
	local dur = 1
	addP("dur",dur)
	setP("SynthDef","player")
	pause(dur)
	die()
end

function ai_BasicGrain()
	initai()
	local dur = 1
	addP("dur",dur)
	setP("SynthDef","grain")
	pause(dur)
	die()
end





function ai_AmpPlayer()
	initai()
	local col = getMeanCol(0)
	local props = {amp = col/255,dur = 5}
	addP(props)
	setP("SynthDef","player")
	pause( getP("dur")  )
	die()
end

function ai_RatePlayer()
	initai()
	local col = getMeanCol(0)
	local props = {rate = col/127,dur = 5}
	addP(props)
	setP("SynthDef","player")
	pause( getP("dur") )
	die()
end

function ai_PosPlayer()
	initai()
	local worldSize =  getWorldSize()
	local pos = getP("pos")
	local props = {start = pos:x()/worldSize:x(), rate = pos:y()/( worldSize:y()*0.5) ,dur = 5 }
	addP(props)
	setP("SynthDef","player")
	pause( getP("dur") )
	die()
end

function ai_PosGrain()
	initai()
	local worldSize =  getWorldSize()
	print(worldSize:x())
	local pos = getP("pos")
	local props = {start = pos:x()/worldSize:x(), rate = pos:y()/( worldSize:y()*0.5) ,dur = 5 }
	addP(props)
	setP("SynthDef","grain")
	pause( getP("dur") )
	die()
end



function ai_PosColPlayer()
	initai()
	local dur = 5
	addP("dur",dur)
	local worldSize =  getWorldSize()
	local pos = getP("pos")
	local col = getMeanCol(0)
	addP("amp",col/255)
	addP("start",pos:x()/worldSize:x())
	addP("rate",pos:y()/( worldSize:y()*0.5) )
	setP("SynthDef","player")
	pause(dur)
	die()
end

function ai_GrainPosPlayer()
	initai()
	local worldSize =  getWorldSize()
	local pos = getP("pos")
	local props = {start = pos:x()/worldSize:x(), rate = pos:y()/( worldSize:y()*0.5) ,dur = 5 }
	addP(props)
	setP("SynthDef","grain")
	pause( getP("dur") )
	die()
end

function ai_GrainPosColPlayer()
	initai()
	local dur = 5
	addP("dur",dur)
	local worldSize =  getWorldSize()
	local pos = getP("pos")
	local col = getMeanCol(0)
	addP("amp",col/255)
	addP("start",pos:x()/worldSize:x())
	addP("speed",pos:y()/( worldSize:y()*0.5) )
	setP("SynthDef","grain")
	pause(dur)
	die()
end


