function ai_BasicBubbler()
  initai()
  addP("spawnrate",0.2)
  print(getP("spawnrate"))
  addP("spawnXrange",30)
  addP("spawnYrange",30)
  addP("grainsize",0.1)
  setP("image",1)
  addP("childBuffer",1)
  addP("childVel",Vec2.new(0,0))
  addP("childAmp",0.03)
  changeMotionModel("Linear")
  local id = getID()
  while true do
  --  print("spawning")
    local xrange = getP("spawnXrange")
    local yrange = getP("spawnYrange")
    local childid = spawnRelative(id,1,"ai_BasicBubble",(math.random()* xrange) - xrange*0.5, (math.random()* yrange) - yrange*0.5 )
    coroutine.yield()
    setPID("bufNum",getP("childBuffer"),childid)
    setPID("Velocity", getP("childVel")  ,childid)
    setPID("amp",getP("childAmp"),childid)
--     setPID("bufNum", 2   ,childid)
    setPID("dur", getPID("grainsize",id),childid)
    
    pause(getPID("spawnrate",id))
  end
  die()
end


function ai_GrainManager()
  initai()
  addP("childAVel",Vec2.new(0,0))
  addP("childBVel",Vec2.new(0,0))
  addP("childCVel",Vec2.new(0,0))
  addP("childDVel",Vec2.new(0,0))
  addP("childBPos",Vec2.new(-10,10))
  addP("childCPos",Vec2.new(10,-10))
  addP("childDPos",Vec2.new(10,10))
  addP("childXrange",10)
  addP("childYrange",10)
  addP("childGrainSize",1)
  addP("childSpawnRate",0.1)
  local id = getID()
  local childAid = spawnRelative(id,1,"ai_BasicBubbler",0,0)
  local childBid = spawnRelative(id,1,"ai_BasicBubbler",0,0)
  local childCid = spawnRelative(id,1,"ai_BasicBubbler",0,0)
  local childDid = spawnRelative(id,1,"ai_BasicBubbler",0,0)
  coroutine.yield()
  while true do
    setPID("spawnrate",getP("childSpawnRate"),childAid)
    setPID("spawnrate",getP("childSpawnRate"),childBid)
    setPID("spawnrate",getP("childSpawnRate"),childCid)
    setPID("spawnrate",getP("childSpawnRate"),childDid)
    setPID("grainsize",getP("childGrainSize"),childAid)
    setPID("grainsize",getP("childGrainSize"),childBid)
    setPID("grainsize",getP("childGrainSize"),childCid)
    setPID("grainsize",getP("childGrainSize"),childDid)
    setPID("spawnXrange",getP("childXrange"),childAid)
    setPID("spawnXrange",getP("childXrange"),childBid)
    setPID("spawnXrange",getP("childXrange"),childCid)
    setPID("spawnXrange",getP("childXrange"),childDid)
    setPID("spawnYrange",getP("childYrange"),childAid)
    setPID("spawnYrange",getP("childYrange"),childBid)
    setPID("spawnYrange",getP("childYrange"),childCid)
    setPID("spawnYrange",getP("childYrange"),childDid)
    setPID("childVel",getP("childAVel"),childAid)
    setPID("childVel",getP("childBVel"),childBid)
    setPID("childVel",getP("childCVel"),childCid)
    setPID("childVel",getP("childDVel"),childDid) 
    local pos = getP("pos") 
    setPID("pos",pos+getP("childAPos"),childAid)
    setPID("pos",pos+getP("childBPos"),childBid)
    setPID("pos",pos+getP("childCPos"),childCid)
    setPID("pos",pos+getP("childDPos"),childDid) 
    
    coroutine.yield()
  end
  die()
end


function ai_Bubbler()
  initai()
  addP("spawnrate",0.2)
  print(getP("spawnrate"))
  addP("spawnXrange",30)
  addP("spawnYrange",30)
  addP("grainsize",0.1)
  changeMotionModel("Physics")
  local id = getID()
  while true do
  --  print("spawning")
    local xrange = getP("spawnXrange")
    local yrange = getP("spawnYrange")
    local childid = spawnRelative(id,1,"ai_Bubble",(math.random()* xrange) - xrange*0.5, (math.random()* yrange) - yrange*0.5 )
    addPID("dur", getPID("grainsize",id),childid)
    pause(getPID("spawnrate",id))
  end
  die()
end





function ai_Spitter()
  initai()
  addP("rate",0.1)
  addP("cmass",0.1)
  addP("cvel",30)
  addP("rot",0.1)
  addP("cmotion","Linear")
  addP("ctype","ai_Emptygrain")
  addP("cSynthDef","default")
  addP("camp",0.02)
  addP("cdur",5)
  changeMotionModel("Linear")  
  local angle = 0
  while true do
      local childid = spawnRelative(getID(),1,getP("ctype"),0,0)
      coroutine.yield()
      angle = angle + getP("rot")
      changeMotionModelID(getP("cmotion"),childid)
      setPID("Mass",getP("cmass"),childid)
      local v = getP("cvel")
      setPID("Velocity",Vec2.new(math.cos(angle)*v,math.sin(angle)*v) ,childid)
      addPID("amp",getP("camp"),childid) 
      setPID("dur",getP("cdur"),childid) 
      setPID("SynthDef",getP("cSynthDef"),childid)
      pause(getP("rate"))
  end
  die()
end




