#include "GreetingDialog.hpp"
#include <QTextBrowser>
#include <QBoxLayout>
#include <QWebView>
#include <QPushButton>
#include <QSettings>
#include <QToolBar>
#include <QAction>
#include <iostream>
#include <QMenu>
#include <QMenuBar>
#include <QMessageBox>

GreetingDialog::GreetingDialog(QWidget* parent, Qt::WindowFlags f): 
  QMainWindow(parent, f),
  m_browser(new QWebView(this)),
   m_layout(new QBoxLayout(QBoxLayout::Down,this))
   
//   m_openAtLaunchButton(new QPushButton("Open at Launch?",this))
{
  m_toolBar = addToolBar("Help");
 
  m_helpMenu = menuBar()->addMenu("Help");
  
  m_loadAction = new QAction(QString("Load on boot?"),this);
  m_loadAction->setEnabled(true);
//   m_loadAction->setCheckable(true);
  m_helpMenu->addAction(m_loadAction);
  
  m_toolBar->addAction(m_loadAction);
  m_toolBar->setEnabled(true);  
  setCentralWidget(m_browser);
//   m_layout->addWidget(m_browser);
  QSettings settings;
  m_loadOnBoot = settings.value("Greeting",true).toBool();
  m_loadAction->setChecked(m_loadOnBoot);
//   m_openAtLaunchButton->setChecked(showGreeting);
  
//    m_layout->addWidget(m_openAtLaunchButton);
  
//   m_openAtLaunchButton->setCheckable(true);
  m_browser->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
//   QString text =  m_textBrowser->loadResource(QTextDocument::HtmlResource,QUrl(":help/welcome.html")).toString();
//   m_textBrowser->setHtml("help/welcome.html");
  m_browser->load(QUrl("http://stephenpearse.co.uk/AgentApi/_lua_api_8hpp.html"));
  
  
  connect(m_loadAction,SIGNAL(triggered()),this,SLOT(load_triggered()));
  
//   setSizePolicy(QSizePolicy( QSizePolicy::MinimumExpanding));
  setMinimumSize(600,600);
}

void GreetingDialog::load_page(QString path)
{
  m_browser->load(QUrl(path));
}

void GreetingDialog::load_triggered()
{
//   std::cout << "Load toggled " << state<< std::endl;
  
  
  QMessageBox::StandardButton ret = QMessageBox::question(this,"Help on Boot?","Would you like the help pages to load upon booting?",QMessageBox::No | QMessageBox::Yes );
    
  if(ret = QMessageBox::Yes){
    m_loadOnBoot = true;
  }else{
    m_loadOnBoot = false;
  }
  
  
  QSettings settings;
  settings.setValue("Greeting",m_loadOnBoot);
  
  
}




void GreetingDialog::closeEvent(QCloseEvent* event)
{
  QSettings settings;
//   settings.setValue("Greeting",m_openAtLaunchButton->isChecked());
  
  
//   QDialog::closeEvent(event);
}
