#ifndef IMAGEMANAGER_HPP
#define IMAGEMANAGER_HPP
#include <QPainter>
#include <QPoint>
#include "TreeNode.hpp"


class ImageManager
{
  ImageManager();
  static ImageManager* s_instance;  
  
public:
  
  static ImageManager* get_instance();
  virtual ~ImageManager();
  void render_image(TreeNode::Ptr node,   QPainter& painter, QPointF& pos,float angle);
};

#endif // IMAGEMANAGER_HPP
