#ifndef LEAPDRIVER_HPP
#define LEAPDRIVER_HPP

#include <iostream>

#include <iostream>
#include "Leap.h"
#include "lua/llimits.h"





class LeapListener : public Leap::Listener{
   
    Leap::Vector m_palmPos;
LeapListener();

public:
    virtual void onInit(const Leap::Controller&);
    virtual void onConnect(const Leap::Controller&);
    virtual void onDisconnect(const Leap::Controller&);
    virtual void onExit(const Leap::Controller&);
    virtual void onFrame(const Leap::Controller&);
    virtual void onFocusGained(const Leap::Controller&);
    virtual void onFocusLost(const Leap::Controller&);
  
    Leap::Vector* get_palm_pos();
};




class LeapManager {
  
  LeapManager();
  LeapListener* m_listener;
  Leap::Controller* m_controller;
public:
  
  static LeapManager& get_instance();
  void start();
};



#endif // LEAPDRIVER_HPP
