#ifndef STATICSURFACE_HPP
#define STATICSURFACE_HPP

#include "Surface.hpp"
#include <string>

class StaticSurface : public Surface
{
    std::string m_path;
public:
    StaticSurface(std::string filepath);
    virtual Surface::SurfaceType is_type() const;
    const std::string& get_path()const;
    virtual void tick(float dt){}
};

#endif // STATICSURFACE_HPP
