#include "StreamSurface.hpp"
#include <iostream>
#include <cassert>
// #include <cv.h>
// #include <highgui.h>
#include <opencv2/opencv.hpp>
// #include "cvcam.h"

StreamSurface::StreamSurface()
{	
  try{					    
    //DebugStream << "Spawning stream surface cameras found="<< ncams <<std::endl;
    m_capture = cvCreateCameraCapture(-1);
//     assert(m_capture && "Could not connect to camera");
    if(!m_capture)throw "Could not open stream";
  }catch(...){
    throw "Could not open stream";  
  }
}



void StreamSurface::tick(float dt)
{
  rawFrame = cvQueryFrame(m_capture);
  if(!rawFrame)return;

#ifdef __APPLE__
  //cvConvert(rawFrame, convertedFrame,CV_BGR2RGB);
//  std::cout << frame->nChannels << " " << frame->depth <<" "<< frame->dataOrder <<std::endl;
 // rawFrame->convertTo(rawFrame,CV_BGR2RGB);
 // if(!convertedFrame)return;
 // set_image(convertedFrame);
 // return;
#endif  


 // if(!frame)return;
  set_image(rawFrame);
}

Surface::SurfaceType StreamSurface::is_type() const
{
    return ST_STREAM;
}

