#ifndef VIDEOSURFACE_HPP
#define VIDEOSURFACE_HPP

#include "Surface.hpp"
#include <string>
/*
#include "cv.h"
#include "highgui.h"
*/

class CvCapture;


class VideoSurface : public Surface
{
  std::string m_filePath;
  CvCapture* m_capture;
public:
    VideoSurface(const std::string& filepath);
    virtual Surface::SurfaceType is_type() const;
    virtual void tick(float dt);
};

#endif // VIDEOSURFACE_HPP
