#ifndef WORLDSERVER_HPP
#define WORLDSERVER_HPP
#include <lo/lo.h>


class WorldEngine;


class WorldServer
{
  WorldEngine* m_engine;
  lo_server_thread m_serverThread;
public:
  WorldServer(WorldEngine* engine, int portNo);
  virtual ~WorldServer();
  void start_server();
  static void error(int num, const char *m, const char *path);
  static int data_handler(const char *path, const char *types, lo_arg **argv,int argc, void *data, void *user_data);
  int quit_handler(const char *path, const char *types, lo_arg **argv, int argc,void *data, void *user_data);
  
  //test function
  static int test(const char* path, const char* types, lo_arg** argv, int argc, void* data, void* user_data);
  
 
  
};

#endif // WORLDSERVER_HPP
