#include <iostream>

#include "TreeNode.hpp"
#include "WorldEngine.hpp"
// #include <sys/time.h>
#include <QApplication>
#include "mainwindow.hpp"
#include "Vec2.hpp"
#include "LuaFunctions.hpp"
#include <stdio.h>
#include <stdlib.h>
#include "Agent.hpp"
#include <QSplashScreen>
#include <QTimer>
#include "Utilities.hpp"
/*
class AgentApp : public QApplication{
  MainWindow m_mainWindow;
  
public:
  AgentApp(int& argc, char** argv):QApplication(argc,argv){
    
    m_mainWindow.setStyleSheet("background-color:rgb(176,176,176);");
    m_mainWindow.show();
    
  }
  ~AgentApp(){
  }
  
  
  
virtual bool notify(QObject* rcv, QEvent* e){
  try{
    QApplication::notify(rcv,e);
  }catch(const std::exception& e){
    QMessageBox::warning(topLevelWidgets().back(),"Warning",e.what());
  }catch(TreeNode::NodeException& e){
    QMessageBox::warning(topLevelWidgets().back(),"Warning",e.what());
    e.node->remove_treenode_from_existence();
    m_mainWindow.update_screen();
  }catch(LuaScript::Exception& e){
    QMessageBox::warning(topLevelWidgets().back(),"Warning",e.what());
    m_mainWindow.update_screen();
  }catch(Agent::AgentException& e){
    QMessageBox::warning(topLevelWidgets().back(),"Warning",e.what());
    m_mainWindow.update_screen();
  }
}

};
*/
 




int main (int argc,char ** argv){
	DebugStream << "Welcome to the Agent Project - (c) Stephen Pearse 2012"<<std::endl;
// 	test_vec2();
	
// // 	WorldEngine::get_instance();
	
// 	char* basicPath;
// 	basicPath = getenv("AgentProjectBasic");
// 	DebugStream << "basic path " << basicPath<<std::endl;
	
// 	WorldEngine::get_instance().load_lua_script(basicPath);
// 	WorldEngine::get_instance().load_lua_script("scripts/basic.lua",true);
// 	WorldEngine::get_instance().set_lo_address("127.0.0.1","57110");
// 	WorldEngine::get_instance().get_world()->add_child(TreeNode::factory(TreeNode::TN_AGENT,"ai_Brain1"));
	
	
	
	/*
	WorldEngine::get_instance().get_world()->add_child(TreeNode::factory(TreeNode::TN_AGENT,"Brain1"));	
// 	WorldEngine::get_instance().get_world()->add_child(TreeNode::factory(TreeNode::TN_AGENT,"Brain1"));
// 	WorldEngine::get_instance().get_world()->add_child(TreeNode::factory(TreeNode::TN_AGENT,"Brain1"));
// 	TreeNode::show_node_hierarchy( DebugStream, WorldEngine::get_instance().get_world() );
// 	TreeNode::show_node_usage(DebugStream);
	WorldEngine::get_instance().tick(1);
// 	TreeNode::show_node_hierarchy( DebugStream, WorldEngine::get_instance().get_world() );
// 	TreeNode::show_node_usage(DebugStream);
	WorldEngine::get_instance().tick(1);
	WorldEngine::get_instance().tick(1);
	timeval prevTime, newTime;
	gettimeofday(&prevTime, NULL);
	double g_dT=0;
	while(true){
		gettimeofday(&newTime, NULL);
		
		g_dT = (newTime.tv_sec - prevTime.tv_sec);
		g_dT += (newTime.tv_usec - prevTime.tv_usec) / 1000000.0;
		
		if(g_dT > 0.001){
			////DebugStream << g_dT << " secs\n";
			prevTime = newTime;
			WorldEngine::get_instance().tick(g_dT);
		}
	}
	
	
	
	
	
// 	TreeNode::show_node_hierarchy( DebugStream, WorldEngine::get_instance().get_world() )	;
	DebugStream << "fini" << std::endl;
*/
	
// 	AgentApp app(argc, argv);
// 		app.processEvents();
	QApplication app(argc,argv);
	
	
	QSplashScreen* splash = new QSplashScreen;
	QPixmap pixmap(":/root/splash");
	if(pixmap.isNull())return -1;
	splash->setPixmap(pixmap);
	splash->show();
// 	splash->
	splash->showMessage("Booting Agent Engine",Qt::AlignLeft, Qt::gray);
	WorldEngine::get_instance().set_lo_address("127.0.0.1","57110");
	app.processEvents();
	splash->showMessage("Initializing interface",Qt::AlignLeft, Qt::gray);
	MainWindow* window = MainWindow::get_instance();
	QTimer::singleShot(1000, splash, SLOT(close()));
	QTimer::singleShot(1000, window, SLOT(show()));
//  	window.setStyleSheet("background-color:rgb(176,176,176;)");
	
	
// 	window.show();
// 	splash->finish(&window);

	return app.exec();
	
}
