--ai_RPosPlayer
--is dependent on realtime players

function ai_BasicGrainSynth( )
	initai()
	local props = {rate = 0.1,cdur = 1,xDeviation = 5, yDeviation=5,childType = "ai_Grain",run = 1,cbufNum = 0, cAmp = 0.7}
	local id = getID()
	changeMotionModel("Path")
	addP(props)
	while getPID("run",id) > 0 do 
		local cArgs = {dur = getPID("cdur",id), bufNum = getPID("cbufNum",id) , amp = getPID("cAmp",id) }
		local xDev = getPID("xDeviation",id)
		local yDev = getPID("yDeviation",id)
		spawnRelativeP(cArgs,id,1,getPID("childType",id), math.random(xDev* -1.0,xDev), math.random(yDev* -1.0,yDev)  )
		pause(  getPID("rate",id) )
	end
	pause(10)
	die()
	-- body
end



 

function ai_Grain()
	initai()
	local worldSize = getWorldSize()
	local speed = getP("pos"):y() /261
	local pan = ((getP("pos"):x()/worldSize:x()) * 2 ) -1
	local col = getRGBA(0)	

	local props = {speed = speed, amp = 1,dur = 0.2,pan = pan,startpos = col:r()/255,amp = 0.2}
	addP(props)
	setP("SynthDef","grain")
	pause(getP("dur"))
	die()
end	


function ai_pathScrewer()
	initai()
	removePath(0)


	for i = 1,20 do
		addPathPoint(0,math.random(0,1000),math.random(0,1000))
	end
	die()
end