

function ai_ChildTester()
  initai()
  local childState = hasChildren()
  print(childState)
  spawnRelative(getID(),1,"ai_testChild",(math.random()* 20) - 20*0.5, (math.random()* 20) - 20*0.5 )
  childState = hasChildren()
  print(childState)
 -- coroutine.yield()
  print(numberOfChildren())
  for i = 1, numberOfChildren() ,1 do
      local childId = getChild(i)
      print("child = ")
      print(childId)
  end  
  
  die()
end



function ai_Broken()
	initai()
	getP("dont exist")
end

function ai_TableTester()
    local stuff = { amp = 0.1 , stuff = "stringy stuff",vector = Vec2.new(20,0)  }
    initai()
    initP(stuff)
    spawnP(stuff,getID(),1,"ai_testChild",100,100)
    spawnRelativeP(stuff,getID(),1,"ai_testChild",10,10)
    pause(10)
    die()
end

function ai_ConstructorTest()
  initai()
  local props = {a = "hello",b = "world",c = 1.0,d = Vec2.new(40,40)}
  initP(props)
  pause(30)
  die()
end


function ai_AddTest()
    initai()
    local test = { a = 0.1,b = 0.2,AAAAAA = Vec2.new(100,100),Velocity = Vec2.new(100,100)}
    addP(test)
    test = {a = 10,b=20}
    setP(test)
    pause(10)
    die()
end

function ai_testChild()
  initai()
  pause(60)
  die()
end

function ai_ChildKiller()
    initai()
    local id = getID()
    print(id)
    setP("image",1)
    for i =0,3,1 do
      spawnRelative(id,1,"ai_testChild",(math.random()* 20) - 20*0.5, (math.random()* 20) - 20*0.5 )
    end 
    pause(5)
    print(id)
    killChildrenID(id)
    pause(30)
    die()
end

function ai_GridTest()
  initai()
  changeMotionModel("physics")
  while true do
  coroutine.yield()  
  end
    
end





function ai_BasicBubble()
    initai() 
    changeMotionModel("Physics")
    local worldsize = getWorldSize()
    addP("bufNum",1)
    addP("amp",0.5)
    addP("speed",getP("pos"):y()/ worldsize:y()*2)
    addP("startpos", getP("pos"):x()/ worldsize:x() )
    addP("pan",0)
    setP("dur",1)
    setP("image",0)
    setP("SynthDef","bubble")
	print("bubble constructed")
    for i = 0 , getP("dur")*1000,1 do
	setP("speed",getP("pos"):y()/worldsize:y()*3 )
	setP("startpos", getP("pos"):x()/ worldsize:x() )
	
    --setP("SynthDef","test")
      pause(0.001)
    end
    die()
end  


local level = 3

function ai_Clusters()
  initai()
  local total  = 0
  setP("image",3)
  addP("spawnXrange",30)
  addP("spawnYrange",30)
  addP("numChildren",math.random()*10)
  addP("rate",math.random()*10)
  addP("grainsize",math.random()*2)
  local id = getID()
  while true do
    for i = 0,getP("numChildren"),1 do
     print(id)
     local xrange = getPID("spawnXrange",id)
     local yrange = getPID("spawnYrange",id)
     local childid = spawnRelative(id,1,"ai_BasicBubble",(math.random()* xrange) - xrange*0.5, (math.random()* yrange) - yrange*0.5 )
     print(id) 
     print(childid)
     setPID("dur", getPID("grainsize",id),childid)
    end  
    pause(getPID("rate",id))
   -- killChildren()
  end
  die()
end
  



function ai_OSCTester()
  initai()
  oscF("127.0.0.1","8001","/hello",1002)
  oscI("127.0.0.1","8001","/hello2","BREAK")
  oscS("127.0.0.1","8001","/hello3","some text")

  pause(1)
  die()
end  



function ai_gravchanger()
  initai()
  addP("rate",1)
  while true do
  setPID("Gravity",Vec2.new( (math.random()*5)-2.5,(math.random()*5)-2.5   ) ,0  )
  pause(getP("rate"))
  end
end


function ai_SimplePlayer()
  initai()
  addP("dur",3)
  addP("amp",0.2)
  setP("SynthDef","fileplayer")
  pause(getP("dur"))
  die()
end

function ai_Bouncer()
  initai()
  changeMotionModel("Physics")
  addP("NoOfBounces",15)
  addP("Spawntype","ai_SimplePlayer")
  setP("Velocity",Vec2.new(10,10))
  local i = 0
  while i < getP("NoOfBounces") do
    local t = detectsurface(getID(),getP("pos"),getP("Spawntype"),0)
    i = i + t 
    coroutine.yield()
  end
  pause(5)
  die()
end

-- Grain Clustering
-- This pair of ais is used to make simple clusters of expanding grains centered on the mouse
function ai_GrainCluster()
	print("spawning grain cluster")
	initai()
	local p = Vec2.new(10,29)
	print(p)
	local dur = 10
	changeMotionModel("Static")
	scNew("default")
	scSet("amp",0.05  )
	local pos = getP("pos")
	print(pos:y())		
	scSet("freq",pos:y()*5)	
	for n = 0,25,1 do	
			pause(0.1)		
			spawnRelative(getID(),1,"ai_LinearWalker",0,0)		
	end		
	while getLifetime()<dur do
			scSet("amp",(1-  (getLifetime()  / dur ) )*0.05   )
			coroutine.yield()
	end	
--	scFree(getID())
	die()
end

function ai_Dropper()
	initai()
	local p = Vec2.new(10,29)
	print(p)
	local dur = 10
	changeMotionModel("Static")
	scNew("default")
	scSet("amp",0.05  )
	local pos = getPosition()
	print(pos.y)		
	scSet("freq",pos.y*5)	
	for n = 0,25,1 do	
			pause(0.1)		
			spawnRelative(getID(),1,"ai_Drop",0,0)		
	end		
	while getLifetime()<dur do
			scSet("amp",(1-  (getLifetime()  / dur ) )*0.05   )
			coroutine.yield()
	end	
--	scFree(getID())
	die()
end
function ai_Drop()
	initai()
	local dur = 3
	local vx = (math.random()-0.5) * 100
	local vy = (math.random()-0.5) * 100
	local pos = getPosition()
	changeMotionModel("Physics")
	setP("Velocity",Vec2.new(0,40))
	addP("amp",(1-  (getLifetime() / dur ) )*0.05)
	addP("freq",pos.y*5)
	setP("SynthDef","default")	
	while getLifetime() < dur do
		dt = getDT();
		move(getID(), vx *dt, vy *dt )
		local pos = getPosition()	
		setP("freq",pos.y*5)	
		setP("amp",(1-  (getLifetime() / dur ) )*0.05   )	
		coroutine.yield()
	end	
	--changeMotionModel("Physics")
	--scFree(getID())
	die()

end
function ai_LinearWalker()
	initai()
	local dur = 5
	local vx = (math.random()-0.5) * 100
	local vy = (math.random()-0.5) * 100
	local pos = getP("pos")	
	addP("amp",(1-  (getLifetime() / dur ) )*0.05)
	addP("freq",pos:y()*5)
  	setP("Mass",0.02)
	setP("SynthDef","default")
  changeMotionModel("Physics")	
	while getLifetime() < dur do
		dt = getDT();
		move( vx *dt, vy *dt )
		local pos = getPosition()	
		setP("freq",pos:y()*5)	
		setP("amp",(1-  (getLifetime() / dur ) )*0.05   )	
		coroutine.yield()
	end	
	--changeMotionModel("Physics")
	--scFree(getID())
	die()

end

--- End of Grain Clustering.



function ai_Emptygrain()
  initai()
  pause(0.1)
  die()
end




function ai_Follower()
  initai()
  changeMotionModel("Physics")
  setP("Mass",0.01   +math.random()*0.3)
  addP("amp",0.05)
  setP("SynthDef","test")
  local r = math.random()*255
  setP("image",math.random()%6)
  while true do
    
    local mypos = getP("pos")
    drawRelative(0,mypos,r,0,0  )
    local targetId = getNearest(mypos)
    --print(targetId)
    local targetPos = getPID("pos",targetId)
    local dir = (targetPos - mypos):norm()
   -- print(dir)
    --setP("Velocity",Vec2.new(10,30))
    setP("Thrust",dir*4 )
    coroutine.yield()
  end

end


function ai_Bubble()
  
  initai()
  changeMotionModel("Physics")
  local pos = getPosition()
  addP("speed",600/pos.y)
  addP("amp",0.1)
  addP("startpos",0.5)
  setP("SynthDef","bubble")
  pause(getP("dur"))
  die()
end



function ai_BasicWalker()
  initai()
  changeMotionModel("Physics")  
  while true do
    coroutine.yield()
  end
end
function ai_TimerTest()
  initai()
  changeMotionModel("Physics")  
  setP("dur",3)
  while true do
    coroutine.yield()
  end
end







--[[

function ai_absspawn()
  initai()
  addP("spawnrate",0.2)
  print(getP("spawnrate"))
  addP("spawnXrange",30)
  addP("spawnYrange",30)
  addP("grainsize",0.1)
  addP("childtype","ai_bubble")
  changeMotionModel("Static")
  local id = getID()
  while true do
  --  print("spawning")
    local xrange = getP("spawnXrange")
    local yrange = getP("spawnYrange")
    local childid = spawnRelative(id,1,getP("childtype"),(math.random()* xrange) - xrange*0.5, (math.random()* yrange) - yrange*0.5 )
    addPID("life", getPID("grainsize",id),childid)
    pause(getPID("spawnrate",id))
  end
  die()
end






function ai_VerticalDrop()
  initai()
  local dur = 10  
  changeMotionModel("Linear")
  scNew(getID(),"grain")
  scSet(getID(),"amp",0.01  )
  local speed = math.random()*5
  while getLifetime(getID()) < dur do
    local dt = getDT()
    move(0,speed)
    local pos = getPosition()
    scSet("freq",pos.y*5)	
    scSet("amp",(1-  (getLifetime() / dur ) )*0.1   )	
    coroutine.yield()
  end
--  scFree(getID())
  die()

end

function ai_VerticalClimb()
  initai()
  changeMotionModel("Linear")
  local dur = 5  
  scNew(getID(),"grain")
  scSet(getID(),"amp",0.01  )
  local speed = math.random()*5
  while getLifetime(getID()) < dur do
    local dt = getDT()
    move(0,speed*(-1))
    local pos = getPosition()
    scSet("freq",pos.y*5)	
    scSet("amp",(1-  (getLifetime() / dur ) )*0.1   )	
    coroutine.yield()
  end
--  scFree(getID())
  die()

end

function ai_HorizontalSweep()
  initai()
  local dur = 5 
  changeMotionModel("Linear")
 
  scNew(getID(),"grain")
  scSet(getID(),"amp",0.5  )
  local speed = math.random()*5
  while getLifetime(getID()) < dur do
    local dt = getDT()
    move(speed,0)
    local pos = getPosition()
    scSet("freq",pos.y*5)	
    scSet("amp",(1-  (getLifetime() / dur ) )*0.1   )	
    coroutine.yield()
  end
--  scFree(getID())
  die()

end

function ai_test()
  initai()
  addP("freq",1000)
  addPID("amp",1,getID())
  setP("SynthDef","default")
  pause(3)
  setP("freq",200)
  pause(3)
  die()
end

function ai_vec()
  initai()
  local t = Vec2.new(100,20)
  local t2 = Vec2.new(30,60)
  local t3 = t2 + 10
  print(t2:dot(t))
  die()
end

function ai_simple()
  initai()
  changeMotionModel("Linear")  
  addP("amp",0.1)
  setP("SynthDef","test")
  for i = 0,10,1 do
    move(0,20)
    pause(2)
  end
  die()
end



function Brain1() 
	initai()
	--print("brain1 activity")
	while true do
		local id = getID()
	--	print("Brain Number "..id )
		--local t = id+1 --math.random() * 5
		--local pos = get_pos()
		--print("x = ".. pos.x .. " " .. pos.y)
		--spawn(0,1,"Brain2",0,0)
		spawn(0,1,"Brain5",0,0)
		pause(0.1)
		
		--print("Waiting for "..t )
		--pause( 2 )
		--set_pos(200,400)
	--	print("Brain before death "..id)
		--kill(id)	
	end
end


function ai_Brain2()
	initai()
	local id = getID()
	local x = math.random()*100 + 200
	local y = math.random()*100 + 200
	
	local ax = 0
	local ay = 0
	local vx = 20
	local vy = 0
	while(true) do
	  local dT = getDT(ai_Brain2)
	  --setPosition(x + t*10,y + math.sin(t)*10)
	  ax = (400 - x) * 0.1
	  ay = (400 - y) * 0.1
	  vx = vx + ax * dT
	  vy = vy + ay * dT
	  x = x + vx * dT
	  y = y + vy * dT
	  
	  setPosition(x,y)

	  pause(0.01)
	end
	--kill(id)
end

function ai_Brain3()
	initai()
	
	local id = getID()
	scNew(id,"default")
	local x = 300
	local y = 300
	local t = 0 
	while (t < 1) do
	  t = t + getDT()
	  local t_x = x + t*200
	  local t_y = y + math.sin(t*4)*50
	  setPosition(t_x,t_y)
	  scSet(id,"freq",t_y)
	  scSet(id,"amp",t*0.1)
	  scSet(id,"pan",t)
	  pause(0.01)
	end
	scFree(id)
	kill(id)
end

function ai_Brain4()
	initai()
	local id = getID()
	scNew(id,"fred") 
	local startX = 250
	local startY = 250
	local dur = (math.random()*5)+0.2
	local destX = math.random()*500
	local destY = math.random()*500
	local t = 0
	while(t < dur)do
	  t = t + getDT()
	  local x = (destX-startX)*(t/dur)+startX
	  local y = (destY-startY)*(t/dur)+startY
	  scSet(id,"freq",500)
	  scSet(id,"amp",0.05)
	  scSet(id,"pan",x/250-1)
	  setPosition(x,y)
	  pause(0.033)
	end
	scFree(id)
	kill(id)
end






function ai_Brain5()
    initai()	
    local startX = 250
    local startY = 250
    local dur = (math.random()*5)+0.2
    local destX = math.random()*500
    local destY = math.random()*500
    local t = 0
    local id = getID()
    scNew(id,"fred")
    local x = math.random()*800
    local y = math.random()*600
    scSet(id,"freq",(600-y)*10)
    scSet(id,"amp",0.07)
    scSet(id,"pan",x/250-1)
    setPosition(x,y)
    pause(math.random()*2)
    scFree(id)
    kill(id)
end


function ai_my()
    initai()	
    local startX = 250
    local startY = 250
    local dur = (math.random()*5)+0.2
    local destX = math.random()*500
    local destY = math.random()*500
    local t = 0
    local id = getID()
    scNew(id,"fred")
    local x = math.random()*800
    local y = math.random()*600
    setPosition(x,y)
    pause(math.random()*2)
    scFree(id)
    kill(id)
end






--]]














