--Here you will find a collection of realtime basic soundfile players. 
--These update continuously over the course of an Agents lifetime.



function ai_RAmpPlayer()
	initai()
	local dur = 5
	local col = getMeanCol(0)
	addP("amp",col/255)
	addP("dur",dur)
	setP("Velocity",Vec2.new(10,0))
	setP("SynthDef","player")
	local dt = 0.01
	for i = 0,dur,dt do
		col = getMeanCol(0)
		setP("amp",col/255)
		pause(dt)
	end
	die()
end

function ai_RRatePlayer()
	initai()
	local dur = 5
	local col = getMeanCol(0)
	addP("rate",col/127)
	addP("dur",dur)
	setP("Velocity",Vec2.new(10,0))
	setP("SynthDef","player")
	local dt = 0.01
	for i = 0,dur,dt do
		col = getMeanCol(0)
		setP("rate",col/127)
		pause(dt)
	end
	die()
end


function ai_RPosPlayer()
	initai()
	local dur = 5
	addP("dur",dur)
	local worldSize =  getWorldSize()
	local pos = getP("pos")
	addP("start",pos:x()/worldSize:x())
	addP("rate",pos:y()/( worldSize:y()*0.5) )
	setP("SynthDef","player")
	local dt = 0.01
	for i = 0,dur,dt do
		worldSize =  getWorldSize()
		pos = getP("pos")
		setP("start",pos:x()/worldSize:x())
		setP("rate",pos:y()/( worldSize:y()*0.5) )
		pause(dt)
	end
	die()
end

function ai_RPosColPlayer()
	initai()
	local dur = 5
	addP("dur",dur)
	local worldSize =  getWorldSize()
	local pos = getP("pos")
	local col = getMeanCol(0)
	addP("amp",col/255)
	addP("start",pos:x()/worldSize:x())
	addP("rate",pos:y()/( worldSize:y()*0.5) )
	setP("SynthDef","player")
	local dt = 0.01
	for i = 0,dur,dt do
		worldSize =  getWorldSize()
		pos = getP("pos")
		col = getMeanCol(0)
		setP("amp",col/255)
		setP("start",pos:x()/worldSize:x())
		setP("rate",pos:y()/( worldSize:y()*0.5) )
		pause(dt)
	end
	die()
end


function ai_RGrainPosPlayer()
	initai()
	local dur = 0.1
	addP("dur",dur)
	local worldSize =  getWorldSize()
	local pos = getP("pos")
	addP("start",pos:x()/worldSize:x())
	addP("speed",pos:y()/( worldSize:y()*0.5) )
	setP("SynthDef","grain")
	local dt = 0.01
	for i = 0,dur,dt do
		worldSize =  getWorldSize()
		pos = getP("pos")
		setP("start",pos:x()/worldSize:x())
		setP("speed",pos:y()/( worldSize:y()*0.5) )
		pause(dt)
	end
	die()
end

function ai_RGrainPosColPlayer()
	initai()
	local dur = 1
	addP("dur",dur)
	addP("amp",0.1)
	local worldSize =  getWorldSize()
	local pos = getP("pos")
	addP("start",pos:x()/worldSize:x())
	addP("speed",pos:y()/( worldSize:y()*0.5) )
	setP("SynthDef","grain")
	local dt = 0.01
	for i = 0,dur,dt do
		worldSize =  getWorldSize()
		pos = getP("pos")
		setP("start",pos:x()/worldSize:x())
		setP("speed",pos:y()/( worldSize:y()*0.5) )
		local col = getMeanCol(0)
		setP("amp",col/255)		
		pause(dt)
	end
	die()
end



